#ifndef POSTLISTRESOURCES_H
#define POSTLISTRESOURCES_H


#include "Utility.h"
#include "UniChar2IndexMap.h"
#include "HashTable.h"
#include "ConfigManager.h"
#include "FileWriter.h"
#include "FileReader.h"


class RecordPtr
{
	public:
		DWord offset;
		Word count;

		RecordPtr(){
			offset=-1;
			count=0;
		}
		bool operator<(RecordPtr rp) const		
		{
			return count<rp.count;
		}
		size_t sizeOf () {
			return sizeof(offset)+sizeof(count);
		}
};


class PostList
{
	public:	
		int *data;
		int size ;
		PostList(){
			data=NULL;
			size=0;
		}

		~PostList();
};

	


class PostListResources
{

private:


//	PostList** bigramPL;
//	PostList* unigramPL;

	vector <int> **vBigramPL;
	vector <int> *vUnigramPL;
	
	int numberOfChars;


	bool SaveBigram(string bigramMatrixFilename, string bigramPLFilename);
	bool SaveUnigram(string unigramListFilename, string unigramPLFilename);

	bool LoadBigramMatrix(string filename);
	bool LoadUnigramList(string filename);



//	UniChar2IndexMap charmap;

public:
	
	RecordPtr** bigramMatrix;
	RecordPtr* unigram;
	
	bool Initialize(HashTable &htable,UniChar2IndexMap &charmap);
	bool Save(ConfigManager &config);
	bool Load(ConfigManager &config);

	void SetNumberOfChars(int num);
	

	PostListResources();

	~PostListResources();

	void DeAllocBigramMatrix();
	void DeAllocUnigramList();
	void DeAllocateVBigramPL();
	void DeAllocateVUnigramPL();

};



#endif