#ifndef UniChar2IndexMap_H
#define UniChar2IndexMap_H

#include <string>
using namespace std;

#include "Utility.h"
#include "FileReader.h"

const int __ULE_CHARSET_PAGE_SIZE = 256;
		  

#define UNDEF_CHAR 0xFFFF

// Class UniChar2IndexMap:
// stores mapping for UCS-2 charset
class UniChar2IndexMap {
	int numOfChars;
	Word* CodePages [__ULE_CHARSET_PAGE_SIZE];
public:
	UniChar2IndexMap ();	// constructor 
	UniChar2IndexMap (const UniChar2IndexMap & );  // copy constructor
	~UniChar2IndexMap ();	// destructor

	bool Initialize(string FilePath);

	int GetTotalNumOfChars ();
	unsigned short GetIndex (wchar_t wc);
	int Insert(wchar_t wc);
	void Clear ();
	
	wstring Validate(wstring word); 
};

#endif