
#ifndef UTILITY_H_HEADER_INCLUDED
#define UTILITY_H_HEADER_INCLUDED


#include <string>
using namespace std;

enum __ULE_UNICODE_FILE_FORMAT {__ULE_UCS_2 = 2, __ULE_UCS_4 = 4};
const __ULE_UNICODE_FILE_FORMAT __ULE_UCS_SIZE = __ULE_UCS_2;

// enums
enum {	__ULE_FAILURE=0x00, __ULE_SUCCESS=0x01,
		__ULE_NO_RESULT=0x02, __NON_EXISTENT_REF_ID=0x03,
		__ULE_HEADWORD_DUPLICATION=0x04,
		FILE_NOT_FOUND=0x10, FILE_READ_ERROR=0x11, 
		FILE_WRITE_ERROR=0x12, FILE_POINTER_ERROR=0x13,
		MEMORY_NOT_ALLOCATED=0x20, INVALID_FILE_FORMAT=0x30,
		__INVALID_ARGUMENT_VALUE=0x31, INDEX_OUT_OF_BOUND=0x40,
		XML_PARSER_INITIALIZATION_FAILED=0x50, XML_PARSER_NOT_INITIALIZED=0x51,
		XML_FILE_NOT_OPEN=0x52,	XML_FILE_READ_ERROR=0x53, INVALID_XML_DOCUMENT=0x54
};
// typedefs
typedef unsigned long	DWord;
typedef unsigned short	Word;
typedef unsigned char	Byte;

// consts
const Word	__ULE_UCS_2_BOM = 0xFEFF; // "Byte Order Market" for UCS-2
const DWord	__ULE_UCS_4_BOM = 0x0000FEFF; // "Byte Order Market" for UCS-4

const DWord	__ULE_UCS_BOM	= __ULE_UCS_2_BOM;


const wchar_t __jezm = 0x0652;
const wchar_t __zebr = 0x064E;
const wchar_t __zer = 0x0650;
const wchar_t __pesh = 0x064F;
const wchar_t __do_zebr = 0x064B;
const wchar_t __do_zer = 0x064D;
const wchar_t __do_pesh = 0x064C;
const wchar_t __shd = 0x0651;
const wchar_t __zebr_above = 0x0670;
const wchar_t __med = 0x0653;

const wchar_t 
	__SPACE			= 0x0020,
	__ZWNJ			= 0x200C,
	__ZWJ			= 0x200D;



// string manipulation routines
//char* Trim (char* str);
string Trim (string& str);
wstring Trim(wstring& wstr);


// converts ascii-based string (string) to unicode-based string (wstring)
wstring String2Wstring (string sString);
// converts unicode-based string (wstring) to ascii-based string (string) 
string WString2String (wstring wsString);

int wstring2int (wstring wstr);


wstring RemoveDiacritics(wstring word);
bool IsWhitespace (wchar_t ch);
wstring RemoveWhitespaces (wstring str);




int EditDistance(wstring s,wstring t);
#endif